Public Class Form1
    Private Const sourceFileNotExist As String = "ҽ   ʽϴ."
    Private Const selectSourceFile As String = "ҽ  ϼ."
    Private Const selectTargetFile As String = "Ÿ  ϼ."
    Private Const targetFileExist As String = "Ÿ  ̹ մϴ. ðڽϱ?"
    Private Const trimDone As String = "ȯ Ϸ!"

    '  νϽ  ۾  ϰ α׷ Ѵ.
    Private Sub ExitApp()
        End
    End Sub

    ' trim.  True ȯ
    Private Function Trim()
        Dim ret As Boolean = False

        '   
        Dim sourceFile As System.IO.FileStream = System.IO.File.OpenRead(SourceFileName.Text)
        Dim targetFile As System.IO.FileStream = System.IO.File.OpenWrite(TargetFileName.Text)

        '    position pointer
        Dim srcPtr, targetPtr As Integer

        Dim buffer(100) As Byte     'read buffer 101 byte size
        Dim byteRead As Integer     'read  ũ.
        Dim byteVal As Byte

        srcPtr = 0
        targetPtr = 0

        While True
            ' ̻      ݺ
            byteRead = sourceFile.Read(buffer, 0, buffer.Length)
            If byteRead = 0 Then
                ret = True
                Exit While
            End If
            srcPtr = srcPtr + byteRead

            For Each byteVal In buffer
                If byteVal <> &HFF Then     ' padding 0xFF ƴϸ write
                    If srcPtr = targetPtr + byteRead Then
                        targetFile.Write(buffer, 0, byteRead)
                        targetPtr = targetPtr + byteRead
                    Else
                        While srcPtr <> targetPtr
                            sourceFile.Seek(targetPtr, IO.SeekOrigin.Begin)
                            byteRead = sourceFile.Read(buffer, 0, buffer.Length)
                            targetFile.Write(buffer, 0, byteRead)
                            targetPtr = targetPtr + byteRead
                        End While
                    End If
                    Exit For
                End If
            Next

        End While

        sourceFile.Close()
        targetFile.Close()

        Return ret
    End Function

    Private Function FileSelect(ByVal isSource As Boolean)
        Dim openFileDialog1 As New OpenFileDialog()
        Dim fileName As String = ""

        openFileDialog1.InitialDirectory = "D:\MyDocuments\NDS\ROM files"
        openFileDialog1.Filter = "NDS ROM Files (*.nds)|*.nds|All files (*.*)|*.*"
        openFileDialog1.FilterIndex = 1
        openFileDialog1.RestoreDirectory = True
        openFileDialog1.CheckFileExists = isSource

        If openFileDialog1.ShowDialog() = DialogResult.OK Then
            'myStream = openFileDialog1.OpenFile()
            'If Not (myStream Is Nothing) Then
            '    ' Insert code to read the stream here.
            '    myStream.Close()
            'End If

            fileName = openFileDialog1.FileName
        End If

        Return fileName
    End Function

    Private Sub BtnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnExit.Click
        ExitApp()
    End Sub

    Private Sub BtnTrim_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnTrim.Click
        If (SourceFileName.Text.Length = 0) Then
            MsgBox(selectSourceFile)
            Return
        End If

        If Not System.IO.File.Exists(SourceFileName.Text) Then
            MsgBox(sourceFileNotExist)
            Return
        End If

        If (TargetFileName.Text.Length = 0) Then
            MsgBox(selectTargetFile)
            Return
        End If

        ' Ÿ  ̹ ϴ . ߺ ˸    
        If System.IO.File.Exists(TargetFileName.Text) Then
            If Not MsgBox(targetFileExist, MsgBoxStyle.OkCancel Or MsgBoxStyle.Information) = MsgBoxResult.Ok Then
                Return
            End If
        End If


        If Trim() = True Then
            MsgBox(trimDone)
        End If
    End Sub

    Private Sub BtnSourceSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSourceSelect.Click
        Dim fileName, extension As String
        Dim fileInfo As System.IO.FileInfo

        '  â ǥϰ ҽ  
        fileName = FileSelect(True)
        If (fileName.Length = 0) Then
            Return
        End If

        ' ҽ  ϴ Ȯ
        If Not System.IO.File.Exists(fileName) Then
            MsgBox(selectSourceFile)
            Return
        End If
        SourceFileName.Text = fileName

        ' ⺻ "_trim" ٿ Ÿ  ̸ 
        fileInfo = My.Computer.FileSystem.GetFileInfo(fileName)
        extension = fileInfo.Extension

        TargetFileName.Text = fileName.Remove(fileName.Length - extension.Length)
        TargetFileName.Text = TargetFileName.Text & "_trim" & extension

    End Sub

    Private Sub BtnTargetSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnTargetSelect.Click
        Dim fileName As String

        fileName = FileSelect(False)
        If (fileName.Length = 0) Then
            Return
        End If

        TargetFileName.Text = fileName
    End Sub
End Class
